package com.seostella.spring;

import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.servlet.ModelAndView;

import com.seostella.spring.domain.Person;
import com.seostella.spring.domain.Sheldon;

@Controller
@RequestMapping( value = "/person/{name}")
public class PersonController {
	
	@RequestMapping(value = "/", method = RequestMethod.GET)
	public ModelAndView showPerson() {
		ModelAndView modelAndView = new ModelAndView("person");
		return modelAndView;
	}
	
	@RequestMapping(value = "/mod", method = RequestMethod.GET)
	public ModelAndView showModifiedPerson(@ModelAttribute("person") Person person) {
		person.setName( person.getName() + " (modified using @ModelAttribute method attribute)" );
		
		ModelAndView modelAndView = new ModelAndView("person");
		return modelAndView;
	}
	
	@ModelAttribute
	public Person addPerson(@PathVariable String name) {
	    return new Person(name);
	}

	@ModelAttribute(value = "personGagarin")
	public Person addGagarinPerson() {
	    return new Person("Gagarin");
	}
	
	@ModelAttribute
	public void populateModel(Model model) {
		model.addAttribute( new Sheldon() );
		model.addAttribute( "personLeonard", new Person("Leonard") );
	}
}
